#include "optionsdlg.h"
#include <aygshell.h>
#include "game.h"
#include "resource.h"

static int
getDifficultyLevel(HWND hDlg)
{
	if (SendDlgItemMessage(hDlg, IDC_DIFF_1, BM_GETCHECK, 0, 0) == BST_CHECKED)
		return 1;
	if (SendDlgItemMessage(hDlg, IDC_DIFF_2, BM_GETCHECK, 0, 0) == BST_CHECKED)
		return 2;
	return 4;
}

static void
setDifficultyLevel(HWND hDlg, int numSuits)
{
	SendDlgItemMessage(hDlg, IDC_DIFF_1, BM_SETCHECK,
			numSuits == 1 ? BST_CHECKED : BST_UNCHECKED, 0);
	SendDlgItemMessage(hDlg, IDC_DIFF_2, BM_SETCHECK,
			numSuits == 2 ? BST_CHECKED : BST_UNCHECKED, 0);
	SendDlgItemMessage(hDlg, IDC_DIFF_4, BM_SETCHECK,
			numSuits == 4 ? BST_CHECKED : BST_UNCHECKED, 0);
}

LRESULT CALLBACK
OptionsBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
	case WM_INITDIALOG:
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_DONEBUTTON | SHIDIF_EMPTYMENU | SHIDIF_SIPDOWN;
		shidi.hDlg = hDlg;
		SHInitDialog(&shidi);

		/* initialize radio button */
		setDifficultyLevel(hDlg, numSuitsToUse);
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			int newDifficulty = getDifficultyLevel(hDlg);
			if (newDifficulty != numSuitsToUse)
			{
				numSuitsToUse = getDifficultyLevel(hDlg);
				cleanup_game();
				game_shuffle();
				start_game();
			}
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

